using System.Collections;

//This class is really just a wrapper to a hashtable.
//Blackboards are used as a shared memory.  The most powerful use of a 
//blackboards in AI is to de-couple different parts of your AI from each 
//other.  The first thing we are using them for is to de-couple the perception
//system from the state-machines and steering behaviors.

//Keys are case insensitive.  This is accomplished by converting them to uppercase 
//before looking up or setting keys.
public class Blackboard {
    Hashtable data;

    public Blackboard()
    {
        data = new Hashtable();
    }

    public void AddData(string strKey, object value)
    {
        string key = strKey.ToUpper();
        //This is where an arbitrator might intervene
        if (data.ContainsKey(key))
        {
            return;
        }

        //BlackboardData bd = new BlackboardData(key, value);
        data.Add(key,value);
    }

    public object GetData(string strKey)
    {
        string key = strKey.ToUpper();
        //This is where an arbitrator might intervene
        if (data.ContainsKey(key))
        {
            return data[key];
        }
        else
        {
            return null;
        }
    }

    public void SetData(string strKey, object value)
    {
        //This is where an arbitrator might intervene
        //This is where an arbitrator might intervene
        string key = strKey.ToUpper();
        if (data.ContainsKey(key))
        {
            data[key] = value;
        }
        else
        {
            AddData(key, value);
        }

    }

}
