using UnityEngine;
using System.Collections;

public class StateFlee : StateMachineState {
	private float originalSpeed;
	
	public StateFlee(StateMachine stateMachine, string stateName):base(stateMachine, stateName)
	{
		//Add transition.... In other words what messages will make this state exit?  To start just have it timeout.
		//The transition should have as its first parameter the string messages and as the second the new state's name
		//To start lets try responding to the MSG_BEHAVIOR_TIMEOUT message and have it transition to the WANDER state
		
		//UNCOMMENT THE CODE BELOW AND PUT THE CORRECT VALUES INSIDE
		//AddTransition("???","???");
		
		//What behavior should we add??? how about the flee steering behavior?? after all this state is the called "StateFlee"
		
		//UNCOMMENT THE LINE BELOW AND CHANGE CLASSES TO CORRECT ONES
		//KinematicWander fleeBehavior = new KinematicWander();
		//Set the behaviors timeout so we can exit from this state!
		//UNCOMMENT THE LINE BELOW AND CHANGE THE METHOD TO THE CORRECT ONE AND PUT APPROPRIATE PARAMETERS INSIDE
		//fleeBehavior.SomeFunction();
		
		//UNCOMMENT THE LINE BELOW AND CHANGE PARAMETER TO MATCH THE BEHAVIOR VARIABLE YOU CREATED ABOVE
		//AddBehavior(aBehavior);
		
	}
	
    public override void OnEnterState()
    {
    	base.OnEnterState();
		Actor actor =  mStateMachine.GetActor();
		actor.SetAnimation("Run");
		actor.mFaceWhereYouAreGoing = true;
		//Store the actors original max speed so we can restore it later
		originalSpeed = (float)actor.GetBlackboard().GetData("MaxSpeed");
		//Speed up the actor so the run animation matches the speed the actor is moving
		actor.GetBlackboard().SetData("MaxSpeed",originalSpeed*3.0f);
    }
    
    public override void OnExitState()
    {
    	base.OnExitState();
    	Actor actor =  mStateMachine.GetActor();
    	actor.mFaceWhereYouAreGoing = false;
    	actor.mMaxSpeed = originalSpeed;
    	actor.GetBlackboard().SetData("MaxSpeed",originalSpeed);
    }
	
}
