using UnityEngine;
using System.Collections;

public class StateWander : StateMachineState {
	public StateWander(StateMachine stateMachine, string stateName):base(stateMachine, stateName)
	{
		AddTransition("MSG_BEHAVIOR_TIMEOUT","IDLE");
		
		//UNCOMMENT CODE BELOW TO ADD A FLEE BEHAVIOR WHEN ANOTHER ACTOR IS NEAR
		//AddTransition("MSG_ACTOR_NEAR","FLEE");
		
		KinematicWander wanderBehavior = new KinematicWander(3.0f);
		AddBehavior(wanderBehavior);
	}
	
    public override void OnEnterState()
    {
    	base.OnEnterState();
		Actor actor =  mStateMachine.GetActor();
		actor.SetAnimation("Walk");
		actor.mFaceWhereYouAreGoing = false;
    }
    
    public override void OnExitState()
    {
    	base.OnExitState();
    	Actor actor =  mStateMachine.GetActor();
    	actor.mFaceWhereYouAreGoing = true;
    }
	
}
